Bug 1369688 - Review Request: python35 - Version 3.5 of the Python programming language
Summary: Review Request: python35 - Version 3.5 of the Python programming language
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Charalampos Stratakis
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-08-24 07:08 UTC by Miro Hrončok
Modified: 2016-09-27 14:51 UTC (History)
3 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2016-09-27 14:51:37 UTC
cstratak: fedora-review+


Attachments (Terms of Use)

Description Miro Hrončok 2016-08-24 07:08:44 UTC
Spec URL: https://github.com/fedora-python/python35/raw/master/python35.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/python35-3.5.2-1.fc23.src.rpm

Description: Python 3.5 package for developers.
No security fixes will be applied.

Fedora Account System Username: churchyard
COPR: https://copr.fedorainfracloud.org/coprs/g/python/python35/

This package is currently intended for Fedora 23 only, later for Fedora 26+.

In the review, please note that this is a backport of the python3 package and the spec might be more complicated than necessary for the sake of much easier portability between python35 and python3.

On the other hand, please be thorough about things like conflicts with python3 package, upgrade paths, etc.

Comment 1 Miro Hrončok 2016-08-24 07:12:51 UTC
Also please note that:

https://fedoraproject.org/wiki/Packaging:ReviewGuidelines#Package_Review_Process

Contributors and reviewers MUST follow the Package Review Process, with the following exceptions:

* The package is being created so that multiple versions of the same package can coexist in the distribution. The package MUST be properly named according to the naming guidelines and MUST NOT conflict with all other versions of the same package.

I'd like the reviewer to check this condition first.

Comment 2 Miro Hrončok 2016-09-13 10:40:21 UTC
Spec URL: https://github.com/fedora-python/python35/raw/master/python35.spec
SRPM URL: https://churchyard.fedorapeople.org/SRPMS/python35-3.5.2-2.fc26.src.rpm

I've backported some recent fixes from the python3 package

Comment 3 Charalampos Stratakis 2016-09-13 13:50:34 UTC
Taking this review.

Upgrade path is clean from F23->F24 with [commit] on python3.

[commit] https://github.com/fedora-python/python3/commit/d97ee1a5e38407a451cd55b70b429b10905fe37b

dnf-0:1.1.10-2.fc25.noarch landed in F25 which should resolve some upgrade path issues, so I should be able to test the upgrade patch from F23->F25 with python35.

Comment 4 Charalampos Stratakis 2016-09-13 14:23:34 UTC
Upgrade path is clean from F23->F25 and no notable issues with python3.

Will proceed testing without an obsoletes tag. Also is there a diff somewhere between the python35 SPEC and the current master branch?

Comment 5 Charalampos Stratakis 2016-09-13 16:32:10 UTC
diff between python35 and master [0]

[0] https://github.com/fedora-python/python35/compare/e4894c0e0b73762a6d32a554582ac85c218e8f8d...master

Removing the obsoletes tag introduces conflicts and the upgrade path is not clean.

For this case the package will be only for Fedora 23 (and F26 when python 3.6 lands?) so I will add respective Obsoletes and Provides tags to the python3 package, in order to keep the upgrade path clean.

When the changes are pushed to python3 I will re-check the SPEC and continue on the review process.

Comment 6 Charalampos Stratakis 2016-09-14 11:32:17 UTC
Commits are pushed for F24 and F25


http://pkgs.fedoraproject.org/cgit/rpms/python3.git/commit/?h=f24&id=a3e9c3436919cd754ce496580ce495e538f440eb

http://pkgs.fedoraproject.org/cgit/rpms/python3.git/commit/?h=f25&id=1768987fbca92f1ea4820046c3f294c8b50ec949

Builds are also done now and will push updates as soon as the builds finish. SPEC seems fine to me and I also tested using python35 package in a F23 VM.

Will do some more testing to ensure everything runs smoothly before I accept the package. although everything seem to be going good.

Comment 7 Charalampos Stratakis 2016-09-15 13:46:39 UTC
Some final notes.

Package is updated to 3.5.2

Rewheel mode is disabled.

Debug build is disabled.

Package is flat, meaning that there are no subpackages, all the files and directories are at the main package.

Most binaries, as well as libraries and man pages are removed so they do not conflict with the system python3 package. The binary for this package is renamed to python35 [0].

[0] https://github.com/fedora-python/python35/commit/9e55727e6d2e48e2377fd312d453746b4e49dbba

python(abi) is not required/provided.

setuptools and pip come bundled with this package so to comply with the packaging guidelines [1], virtual provides are added [2]

[1] https://fedoraproject.org/wiki/Bundled_Libraries?rd=Packaging:Bundled_Libraries#Requirement_if_you_bundle

[2] https://github.com/fedora-python/python35/commit/32884823a3aa88983fe8370f6696a11068cdecfe

%{pylibdir} gets expanded to %{_libdir}/python3.5 so it will not conflict with %{_libdir}/python3.4 at F23.

Also after some testing on F23 VM's I did not notice any regressions. 

'python3' command fires up the python 3.4.2 shell and 'python35' the 3.5.2 shell.

Please, before you make a build and push it to the repos, wait for [3][4] to be pushed to stable repos, so no one will get caught in an upgrade path issue.

[3] https://bodhi.fedoraproject.org/updates/FEDORA-2016-2e71caf3e6
[4] https://bodhi.fedoraproject.org/updates/FEDORA-2016-d49f8ec161

Package accepted.

Comment 8 Charalampos Stratakis 2016-09-15 15:15:18 UTC
Also a correction to my previous comment.

Please consider building the package in a timeframe of 2+ weeks, so that enough people will have updated their F23 systems, in order to get the latest release of python3, which keeps the upgrade path clean.

Comment 9 Miro Hrončok 2016-09-15 15:32:05 UTC
(In reply to Charalampos Stratakis from comment #8)
> Also a correction to my previous comment.
> 
> Please consider building the package in a timeframe of 2+ weeks, so that
> enough people will have updated their F23 systems, in order to get the
> latest release of python3, which keeps the upgrade path clean.

Actually the updated python3 is not in F23, only in F24+, so this does not make any sense. All I need is to wait until it reaches stable and mirrors.

Comment 10 Charalampos Stratakis 2016-09-15 20:30:16 UTC
(In reply to Miro Hrončok from comment #9)
> (In reply to Charalampos Stratakis from comment #8)
> > Also a correction to my previous comment.
> > 
> > Please consider building the package in a timeframe of 2+ weeks, so that
> > enough people will have updated their F23 systems, in order to get the
> > latest release of python3, which keeps the upgrade path clean.
> 
> Actually the updated python3 is not in F23, only in F24+, so this does not
> make any sense. All I need is to wait until it reaches stable and mirrors.

Yes you are correct. This is applicable for the fedora-repos package which caused an issue with the upgrade path, and an update was sent out recently for F23. Apologies for the confusion.

https://bodhi.fedoraproject.org/updates/FEDORA-2016-772911949e

Comment 11 Fedora Update System 2016-09-17 10:22:26 UTC
python35-3.5.2-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-7779c5e531

Comment 12 Fedora Update System 2016-09-18 11:20:51 UTC
python35-3.5.2-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-7779c5e531

Comment 13 Fedora Update System 2016-09-27 14:51:37 UTC
python35-3.5.2-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.